// Header File
// Created 7/12/2004; 5:57:02 PM

#ifndef __ALL__
#define __ALL__


#include <tigcclib.h>
#include "menudefine.h"
#include "menuheader.h"
#include "chicoriedefine.h"
#include "chicorieheader.h"
#include "jump4everdefine.h"
#include "jump4everheader.h"
#include "paperplaneheader.h"
#include "paperplanedefine.h"
#include "skateDefine.h"
#include "extgraph.h"
#include "tilemap.h"
#include "structures.h"

//#define qqq	while(!_keytest(RR_ENTER)){};while(_keytest(RR_ENTER)){}; //Used while debugging
enum score_type {jump_forever,paper_plane,skate_board,no_score}; 

 
void *UNIVERSAL_POINTER;
void *pause_buffer;
SAVE_STRUCT save;


//***************************************************
//***************************************************
unsigned char number_sprite[10][8] = {
{0x7C,0xFE,0xC6,0xC6,0xc6,0xc6,0xFE,0x7C},
{0x38,0x38,0x18,0x18,0x18,0x18,0x3C,0x3C},
{0x7C,0xFE,0x86,0x0E,0x1C,0x38,0x76,0xFE},
{0x7C,0xFE,0x06,0x7C,0x7C,0x06,0xFE,0x7C},
{0x1C,0x3C,0x6C,0x6C,0xCC,0xFE,0xFE,0x0C},
{0xFE,0xFC,0xC0,0xFC,0x7E,0x06,0xFE,0xFC},
{0x7E,0xFE,0xC2,0xFC,0xFE,0xC6,0xFE,0x7C},
{0xFE,0xFE,0x8C,0x0C,0x18,0x18,0x30,0x30},
{0x7C,0xFE,0xC6,0x7C,0x7C,0xC6,0xFE,0x7C},
{0x7C,0xFE,0xC6,0xFE,0x7E,0x86,0xFE,0x7C}};


//  Those 3 functions comes from Kevin's Kofler Backgammon.

//:;;;;;;;;;;;;;;;;;;;;://:;;;;;;;;;;;;;;;;;;;;:
//:;;;;;;;;;;;;;;;;;;;;://:;;;;;;;;;;;;;;;;;;;;:
HANDLE get_handle() {
	SYM_ENTRY *sym=SymFindPtr($(opacksav),0);
	HANDLE handle;
	if (sym) {
		if (sym->flags.bits.archived) {
			if (!EM_moveSymFromExtMem($(opacksav),HS_NULL)) return(H_NULL);
		}
		handle=HeapRealloc(sym->handle,47);
		sym=SymFindPtr($(opacksav),0);
	} else {
		HSym hsym=SymAdd($(opacksav));
		//if (!*(unsigned long *)&hsym) return(H_NULL);
		handle=HeapAlloc(47);
		if (handle)
		sym=DerefSym(hsym);
		else
		SymDel($(opacksav));
	}
	if (!handle) return(H_NULL);
	sym->handle=handle;
	return(handle);     
}

//:;;;;;;;;;;;;;;;;;;;;://:;;;;;;;;;;;;;;;;;;;;:
//:;;;;;;;;;;;;;;;;;;;;://:;;;;;;;;;;;;;;;;;;;;:

void write_data(SAVE_STRUCT *s) {
	HANDLE h = get_handle();
	if (!h)
	return;

	short *fptr=HeapDeref(h);
  //First octet will record the size of the file. (I had to find this out by myself, so this comment might help some people!)
	*fptr=45;
	memcpy(fptr+1,s,sizeof(SAVE_STRUCT));
  memcpy(fptr+20,(char [7]){0,'H','S','C',' ',0,OTH_TAG},7);
	return;
}

//:;;;;;;;;;;;;;;;;;;;;://:;;;;;;;;;;;;;;;;;;;;:
//:;;;;;;;;;;;;;;;;;;;;://:;;;;;;;;;;;;;;;;;;;;:

void read_data(SAVE_STRUCT *s) {
	HANDLE h = get_handle();
	if (!h)
	return;
	short *fptr=HeapDeref(h);
  memcpy(s,fptr+1,sizeof(SAVE_STRUCT));
}


//***************************************************
//***************************************************
void ALL_draw_score(int score, char col, char y, void *plane1, void *plane2) {
	int i;
	char r[5];
	sprintf(r,"%i",score);
	for (i=3;i--;) { //"only" scores up tp 999 will be correctly shown
 		if (r[i] >47 && r[i] < 58)
 		GrayTile8x8_OR_R(i+col,y,number_sprite[r[i]-48],number_sprite[r[i]-48],plane1,plane2);//GrayGetPlane(0), GrayGetPlane(1));
	}
}


//***************************************************
//***************************************************
void draw_pic(unsigned char* src1,unsigned char*src2, unsigned char*dest1,unsigned char* dest2, char width, char height, int n) {    
	int loop;
  GrayClearScreen();
  for (loop=0;loop<height;loop++,src2+=width,dest2+=30,src1+=width,dest1+=30) {
  	memcpy(dest2,src2,width);
    memcpy(dest1,src1,width);
  }
  
	
	if (n!=no_score) {
  read_data(&save);
	char ii[20];
	FontSetSys(F_6x8);
	sprintf(ii,"~High Score:%i~",save.score[n]);
	GrayDrawStr(30,52,ii,A_NORMAL);
	}
}
//***************************************************
//***************************************************

void pause(short a) {

	
	if (_keytest(RR_2ND)) {
		char *b1=GrayGetPlane(0);
		char *b2=GrayGetPlane(1);
		if (a==1) {
			b1 = GrayDBufGetActivePlane(0);
			b2 = GrayDBufGetActivePlane(1);
		}
		FontSetSys(F_8x10);
		memcpy(pause_buffer,b1+45*30,30*8);
		memcpy(pause_buffer+30*8,b2+45*30,30*8);
		GrayDrawStr2B(45,45,"*Pause*",A_NORMAL,b1,b2);
		while (!_keytest(RR_ENTER)) {};
		while (_keytest(RR_ENTER)) {};
		memcpy(b1+45*30,pause_buffer,30*8);
		memcpy(b2+45*30,pause_buffer+30*8,30*8);
	}
}

//pfdgjoadsjgosdjfgosjdflldfnldnjkfljbl;vc jb;xvlncixnuc;c b
//shdfn ouo nusadounfvw0ouv0r8tuc8e8nyrg[qvcbe8pnvsodmucfposudnv

enum game_number {g_CH,g_JU,g_PA,g_SK};


void new_game(int type) {
	read_data(&save);
	save.num_of_games_played[type]++;
	write_data(&save);
}

//pfdgjoadsjgosdjfgosjdflldfnldnjkfljbl;vc jb;xvlncixnuc;c b
//shdfn ouo nusadounfvw0ouv0r8tuc8e8nyrg[qvcbe8pnvsodmucfposudnv
#endif
